package org.duckdb;

import java.sql.SQLException;

final class JdbcUtils {

    @SuppressWarnings("unchecked")
    static <T> T unwrap(Object obj, Class<T> iface) throws SQLException {
        if (!iface.isInstance(obj)) {
          throw new SQLException(
              obj.getClass().getName() + " not unwrappable from " + iface.getName());
        }
        return (T) obj;
    }

    private JdbcUtils() {}
}
